using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Transactions;


public partial class StoredProcedures
{
  [Microsoft.SqlServer.Server.SqlProcedure]
  public static void DoDistributed()
  {
    string ConnStr = 
      "server=.\\sql1;integrated security=sspi;database=pubs";
    using (TransactionScope ts = new TransactionScope())
    using (SqlConnection conn1 = 
           new SqlConnection("Context connection=true"))
    using (SqlConnection conn2 = 
           new SqlConnection(ConnStr))
    {
      // do work on connection 1
      conn1.Open();
      SqlCommand cmd1 = new SqlCommand("insert jobs values('row1',10,10)", conn1);
      cmd1.ExecuteNonQuery();
      // do work on connection 2
      // ask to commit the distributed transaction
      conn2.Open();
      SqlCommand cmd2 = new SqlCommand("insert jobs values('row2',10,10)", conn2);
      cmd2.ExecuteNonQuery();

      ts.Complete();
    }
  }
};
